<?php
// WebJaxe, Observatoire de Paris, licence GPL
// encodage : UTF-8

// affiche la page pour la gestion des contributions
// nécessite tete_pied.php, contributions.php, projets.php, base_de_donnees.php, utilisateurs.php, et l'initialisation des strings et des erreurs
function page_gestion_des_contributions($id_projet=false) {

    debut_html(GESTION_CONTRIBUTIONS, GESTION_CONTRIBUTIONS);
    $dossier_sites = $_SESSION['chemin_dossier_apercu'];
    
    if ($id_projet != false)
        $liste_projets = array(0 => projet($id_projet));
    else
        $liste_projets = liste_des_projets();
    if ($liste_projets != FALSE) {
        for ($i=0; $i<count($liste_projets); $i++) {
            $projet = $liste_projets[$i];
            $id_projet = $projet['id'];
            $titre_projet = $projet['titre'];
            $liste_contributions = liste_des_contributions_projet($id_projet);
            echo '<p class="soustitre">'.PROJET.' <em>'.$titre_projet."</em></p>\n";
            if ($liste_contributions != FALSE) {
                echo '<table cellpadding="6" cellspacing="0" border="1" class="table_administration">'."\n";
                echo '<tr><th>'.NOM.'</th><th>'.DERNIER_AUTEUR.'</th><th>'.DATE.'</th><th colspan="3">'.ACTIONS.'</th></tr>'."\n";
                for ($j=0; $j<count($liste_contributions); $j++) {
                    $contribution = $liste_contributions[$j];
                    $id_contribution = $contribution['id'];
                    $nom_contribution = $contribution['nom'];
                    $liste_historique_contrib = liste_des_historiques_contribution($id_contribution);
                    echo "<tr>\n";
                    echo '<td><b>'.$nom_contribution."</b></td>\n";
                    $historique_contrib = $liste_historique_contrib[0];
                    $id_utilisateur = $historique_contrib['id_utilisateur'];
                    if ($id_utilisateur != FALSE) {
                        $utilisateur = utilisateur($id_utilisateur);
                        echo '<td>'.$utilisateur['prenom'].' '.$utilisateur['nom']."</td>\n";
                    } else
                        echo "<td></td>\n";
                    $date_edition = $historique_contrib['dossier_historique'];
                    if ($date_edition != FALSE) {
                        $morceaux = explode('T', $date_edition); // on garde juste la date
                        echo '<td>'.$morceaux[0]."</td>\n";
                    } else
                        echo "<td></td>\n";
                    echo '<td><a href="administration.php?page=projet_contribution&amp;id_contribution='.$id_contribution.'" class="petit_bouton">';
                    echo CHANGER_PROJET.'</a></td>'."\n";
                    echo '<td><a href="../partie_utilisateur/index.php?page=edition_contribution&amp;id_contribution='.$id_contribution.'" class="petit_bouton">';
                    echo '<img src="../../design/icones/editer.gif" class="icone" border="0"> '.EDITER.'</a></td>'."\n";
                    /*
                    if (is_file("../../".$dossier_sites."/".$nom_contribution."/index.html")) {
                        echo '<td><a href="../../'.$dossier_sites.'/'.$nom_contribution.'/index.html" class="petit_bouton">';
                        echo '<img src="../../design/icones/site.gif" class="icone" border="0"> '.APERCU.'</a></td>'."\n";
                    } else
                        echo "<td></td>\n";
                    */
                    echo '<td><a href="administration.php?action=supprimer_contribution&amp;id='.$id_contribution.'" class="petit_bouton">';
                    echo '<img src="../../design/icones/poubelle.gif" class="icone" border="0"> '.SUPPRIMER."</a></td>\n";
                    echo "</tr>\n";
                }
                echo "</table>\n";
            }
            echo "<br>\n";
        }
    }
    
    //interface pour ajouter une contribution
    echo '<div class="formulaire">'."\n";
    echo '<p class="soustitre">'.TITRE_AJOUTER_CONTRIBUTION.'</p>'."\n";
    echo '<form method="POST" action="administration.php" name="formulaire_ajout_contribution">'."\n";
    echo '<input type="hidden" name="action" value="ajout_contribution">'."\n";
    echo '<input type="text" name="nom_contribution" class="texte" maxlength="20">';
    
    echo ' <select name="id_projet">';
    $liste_projets = liste_des_projets();
    if ($liste_projets != FALSE) {
        for ($i=0; $i<count($liste_projets); $i++) {
            $id_projet = $liste_projets[$i]['id'];
            $titre_projet = $liste_projets[$i]['titre'];
            echo '<option value="'.$id_projet.'">'.$titre_projet.'</option>';
        }
    }
    echo '</select> ';
    
    echo ' <select name="config">';
    echo '<option value="'.$_SESSION['chemin_configuration_jaxe'].'">'.$_SESSION['chemin_configuration_jaxe'].'</option>';
    $fichiers_configuration_jaxe = liste_configs();
    for ( $i = 0; $i < count($fichiers_configuration_jaxe); $i++ )
    {
        $nom = $fichiers_configuration_jaxe[$i];
        if ($nom != $_SESSION['chemin_configuration_jaxe'])
            echo '<option value="'.$nom.'">'.$nom.'</option>';
    }
    echo '</select> ';
    echo '<input type="submit" name="ajouter" value="'.AJOUTER.'" class="valider">';
    echo "</form>\n";
    echo "</div>\n"; // formulaire
    
    echo '<p><a href="administration.php?page=accueil">'.RETOUR."</a></p>\n";
    
    fin_html();
}

function liste_configs() {
    $handle = opendir('../../config');
    while ( $fichier = readdir($handle) )
        if ($fichier != '.' and $fichier != '..' and is_dir('../../config/'.$fichier))
            $fichiers_configuration_jaxe[] = $fichier;
    closedir($handle);
    return($fichiers_configuration_jaxe);
}


// Ajoute une contribution à partir de son nom dans une requête POST
function action_ajout_contribution() {
    
    if (!isset($_POST['nom_contribution']) || !isset($_POST['id_projet']) || !isset($_POST['config']))
        erreur(PARAMETRES_MANQUANT);
    $nom_contribution = $_POST['nom_contribution'];
    $id_projet = $_POST['id_projet'];
    verifie_id($id_projet);
    $config = $_POST['config'];
    
    creer_contribution($nom_contribution, $id_projet, $config);
    page_gestion_des_contributions();
}


// Supprime une contribution à partir de son id dans une requête GET
function action_supprimer_contribution() {
    
    if (!isset($_GET['id']))
        erreur(PARAMETRES_MANQUANT);
    $id_contribution= $_GET['id'];
    verifie_id($id_contribution);
    
    if (supprimer_contribution($id_contribution))
        page_gestion_des_contributions();
    else
        erreur(CONTRIBUTION_PAS_SUPPRIMEE);
}

?>
